#!/bin/bash
# Paul Kroon
# Collect timing data

# Parse pairs file to get domain name, nameserver name, and nameserver IP
i=1
filelength=`cat "$1" | wc -l`

while [ "$i" -le "$filelength" ] ; do

echo "?" >> collecttime.log
echo "?" >> digs
echo "$i" >> collecttime.log
echo "$i" >> digs

# Get first nameserver info
domain_name1=`head -n $i $1 | tail -n 1 | cut -d "?" -f 1`
nameserver_name1=`head -n $i $1 | tail -n 1 | cut -d "?" -f 2`
nameserver_ip1=`head -n $i $1 | tail -n 1 | cut -d "?" -f 3`
#

echo -n "$nameserver_name1"
echo " being used as NS1"
echo -n "$nameserver_name1" >> collecttime.log
echo " being used as NS1" >> collecttime.log

# Get second nameserver info
domain_name2=`head -n $i $1 | tail -n 1 | cut -d "?" -f 4`
nameserver_name2=`head -n $i $1 | tail -n 1 | cut -d "?" -f 5`
nameserver_ip2=`head -n $i $1 | tail -n 1 | cut -d "?" -f 6`
#

echo -n "$nameserver_name2"
echo " being used as NS2"
echo -n "$nameserver_name2" >> collecttime.log
echo " being used as NS2" >> collecttime.log

echo -n "$nameserver_name1" >> timedata
echo -n ":" >> timedata
echo -n "$nameserver_name2" >> timedata
#



# Query NS1 for NS record of domain name and A record of nameserver name
echo -n "Caching."
dig @"$nameserver_ip1" "$domain_name2" NS > /dev/null
echo -n "."
dig @"$nameserver_ip1" "$nameserver_name2" A > /dev/null
echo -n "."
echo "caching complete"
#



# Query NS1 for itself 3 times, record data
echo -n "Querying NS1 for itself"
for k in 1 2 3 ; do
echo -n ":" >> timedata
echo -n "."
dig +norecurse @"$nameserver_ip1" "$nameserver_name1" > temp

status=`cat temp | grep ">>HEADER<<" | cut -d ' ' -f 6 | tr -d ','`
if [ "$status" != "NOERROR" ] ; then
  echo -n "X" >> timedata
  echo "NS1 timeout" >> collecttime.log
  continue
fi

cat temp | grep "Query time" | cut -d " " -f 4 | tr -d '\n' >> timedata
cat temp >> digs
	# echo -n `dig @"$nameserver_ip1" "$nameserver_name1" | grep "Query time" | cut -d " " -f 4` >> timedata
done
echo "done"
#



# Query NS2 from NS1 for arbitrary domain name
echo -n "Querying NS2 with NS1"
for k in 1 2 3 ; do
sample_domain_name=`randchar 10 | tr -d '\n'`'.'${domain_name2}
echo -n ":" >> timedata
echo -n "$sample_domain_name" >> timedata
echo "$sample_domain_name" >> collecttime.log
echo -n "."
dig @"$nameserver_ip1" "$sample_domain_name" > temp

status=`cat temp | grep ">>HEADER<<" | cut -d ' ' -f 6 | tr -d ','`
if [ "$status" != "NXDOMAIN" ] ; then
  echo "Status not NXDOMAIN" >> collecttime.log
  if [ "$status" != "NOERROR" ] ; then
    echo -n ":" >> timedata
    echo -n "X" >> timedata
    echo "Status not NOERROR" >> collecttime.log
    continue
  fi
fi

echo -n ":" >> timedata
time=`cat temp | grep "Query time" | cut -d " " -f 4 | tr -d '\n'`
echo -n "$time" >> timedata
echo "$time" >> collecttime.log
cat temp >> digs
	# echo -n `dig @"$nameserver_ip1" "$sample_domain_name" A | grep "Query time" | cut -d " " -f 4` >> timedata
done
echo "done"
echo >> timedata

i=`expr "$i" + 1`
done

rm temp
